Attribute VB_Name = "modIOConnection"
Option Explicit

Public vmeter As AgilentIOUtilsLib.AgtIOServer


Public Function isconnected(server As AgilentIOUtilsLib.AgtIOServer, Optional ByVal address As String = "", _
                            Optional modelNumber As String, _
                            Optional ByVal showMsg As Boolean = True) As Boolean
'*****************************************************
' Purpose: Using the address or the server, tries to establish a connnection
'           returns the model number
'           Returns a valid server if only given a correct address and a new server
' If the address is different than the passed server a new connection is established
'*****************************************************
    Dim result As String
    Dim resultArray() As String
    Dim Timeout As Long
    Dim msg As String
    Dim io_mgr As AgilentIOUtilsLib.AgtIOManager

    On Error Resume Next
    
    If Len(address) < 6 Then address = server.ConnectionName

    If (server Is Nothing) Or _
       (server.ConnectionName <> address) Then

        On Error Resume Next
        Set server = Nothing
        Set io_mgr = New AgilentIOUtilsLib.AgtIOManager
        Set server = io_mgr.ConnectToInstrument(address)

        If Err.number <> 0 Then
            If showMsg Then
                msg = "Unable to connect to instrument at address: " & address
                MsgBox msg, vbCritical, App.Title
            End If
            isconnected = False
            ' EXIT FUNCTION
            Exit Function
        End If
    End If


    ' check for model number or if it is really connected
    Timeout = server.Timeout
    server.Timeout = 500
    server.Output "END ALWAYS"
    server.Output "ID?"
    server.Enter result

    If Err.number <> 0 Then
        ' Maybe it is 488.2 compliant instrument
        ' try *IDN?
        On Error Resume Next

        server.Output "*IDN?"
        server.Enter resultArray

        If Err.number = 0 Then
            modelNumber = resultArray(1)
            isconnected = True
        Else
            If showMsg Then
                msg = "Unable to connect to instrument at address "
                msg = msg & vbCrLf & address
                MsgBox msg, vbCritical
            End If

            isconnected = False
            Exit Function
        End If

    Else
        modelNumber = Left$(result, Len(result) - 2)
        isconnected = True
    End If

    server.Timeout = Timeout


End Function


